package com.zell_mbc.publicartexplorer.data

import android.app.Application
import android.content.Context
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.datastore.preferences.preferencesDataStore
import androidx.lifecycle.AndroidViewModel
import com.zell_mbc.publicartexplorer.Artwork
import com.zell_mbc.publicartexplorer.Relation

/*val ARTWORK_TYPES_KEY = stringPreferencesKey("artwork_types")
val RADIUS_KEY = intPreferencesKey("radius")
val EXPERT_MODE_KEY = booleanPreferencesKey("expert_mode")
val LONGITUDE_KEY = doublePreferencesKey("longitude")
val LATITUDE_KEY = doublePreferencesKey("latitude")
val ZOOM_KEY = doublePreferencesKey("zoom")
val LOAD_POSITION_KEY = booleanPreferencesKey("load_position")*/



val Context.dataStore by preferencesDataStore(name = "settings")

class ViewModel(application: Application) : AndroidViewModel(application) {

    var artworks by mutableStateOf(listOf<Artwork>())
    val relations = mutableListOf<Relation>()

    fun resetArtworkList(newList: List<Artwork>) {
        artworks = newList
    }


    //private val context = application.applicationContext
/*
    val tileStreamProvider = TileStreamProvider { row, col, zoomLvl ->
        FileInputStream(File("path/{$zoomLvl}/{$row}/{$col}.jpg")) // or it can be a remote HTTP fetch
    }

    val mapState = MapState(4, 4096, 4096).apply {
        addLayer(tileStreamProvider)
        enableRotation()
    }
*
    // Load Position
    val getLoadPosition = application.getLoadPositionStateFlow(scope = viewModelScope, default = Constants.DEFAULT_LOAD_POSITION)
    fun Context.getLoadPositionStateFlow(scope: CoroutineScope, default: Boolean): StateFlow<Boolean> = dataStore.data
        .map { prefs -> prefs[LOAD_POSITION_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setLoadPosition(value: Boolean) {viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[LOAD_POSITION_KEY] = value } } }

    // Expert Mode
    val getExpertMode = application.getExpertModeStateFlow(scope = viewModelScope, default = Constants.DEFAULT_EXPERT_MODE)
    fun Context.getExpertModeStateFlow(scope: CoroutineScope, default: Boolean): StateFlow<Boolean> = dataStore.data
        .map { prefs -> prefs[EXPERT_MODE_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setExpertMode(value: Boolean) {viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[EXPERT_MODE_KEY] = value } } }

    val getRadius = application.radiusStateFlow(scope = viewModelScope, default = Constants.DEFAULT_RADIUS)
    fun Context.radiusStateFlow(scope: CoroutineScope, default: Int): StateFlow<Int> = dataStore.data
        .map { prefs -> prefs[RADIUS_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setRadius(value: Int) {viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[RADIUS_KEY] = value } } }

    // Coordinates
    val getLongitude = application.longitudeStateFlow(scope = viewModelScope, default = null)
    fun Context.longitudeStateFlow(scope: CoroutineScope, default: Double?): StateFlow<Double?> = dataStore.data
        .map { prefs -> prefs[LONGITUDE_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    val getLatitude = application.latitudeStateFlow(scope = viewModelScope, default = Constants.DEFAULT_LATITUDE)
    fun Context.latitudeStateFlow(scope: CoroutineScope, default: Double?): StateFlow<Double?> = dataStore.data
        .map { prefs -> prefs[LATITUDE_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setLongitude(value: Double) { viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[LONGITUDE_KEY] = value } } }
    fun setLatitude(value: Double)  {viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[LATITUDE_KEY] = value } } }


    // Artwork Type
    val getArtworkTypes = application.artworkTypesStateFlow(scope = viewModelScope, default = Constants.DEFAULT_ARTWORK_TYPES)
    fun Context.artworkTypesStateFlow(scope: CoroutineScope, default: String): StateFlow<String> = dataStore.data
        .map { prefs -> prefs[ARTWORK_TYPES_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setArtworkTypes(value: String) {viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[ARTWORK_TYPES_KEY] = value } } }

    // Zoom
    val getZoom = application.zoomStateFlow(scope = viewModelScope, default = Constants.DEFAULT_ZOOM)
    fun Context.zoomStateFlow(scope: CoroutineScope, default: Double): StateFlow<Double> = dataStore.data
        .map { prefs -> prefs[ZOOM_KEY] ?: default }
        .stateIn(scope, SharingStarted.WhileSubscribed(5000), default)

    fun setZoom(value: Double) {
        viewModelScope.launch { getApplication<Application>().dataStore.edit { prefs -> prefs[ZOOM_KEY] = value } } }*/
}
